import Lexer, re, string


def idfunc(m):
    return string.atoi(m.group(0))

class mathlex(Lexer.Lexer):

    id = re.compile(r"([1-9]([0-9]+)?)|0")
    lparen = re.compile(r"\(")
    rparen = re.compile(r"\)")
    
    times = re.compile(r"\*")
    plus = re.compile(r"\+")
    ws = re.compile(r"\s+")


    def __init__(self):
	Lexer.Lexer.__init__(self)
	self.addmatch(self.id, idfunc, "id")
	for p,t in ( (self.plus, "plus"), (self.times,"times"),
		     (self.lparen, "lparen"), (self.rparen, "rparen"),):
	    self.addmatch(p,None, t)
	self.addmatch(self.ws, None, "", Lexer.SKIPTOK)
	


lexer = mathlex()
